<?php
namespace Factory;

use Teknisa\Model\Teknisa\Entities\OmIpRestriction as IpRestrictionEntity;
use Util\InstanceProvider;

class IpRestriction {

    public function save(IpRestrictionEntity $ipRestriction=null, $orgId, $currentOrgId, $codOperador, $dateNow, $description, $ipv4, $ipv6, $active)
    {
        if ($ipRestriction === null){
            $ipRestriction = new IpRestrictionEntity;
            $novoCodigo = InstanceProvider::getLibNewCode()->getCodeByTableName("OmIpRestriction", $orgId, 1, 10, true);
            $ipRestriction->setCdoperinclusao($codOperador);
            $ipRestriction->setNrIpRestriction($novoCodigo);
            $ipRestriction->setNrorginclusao($currentOrgId);
            $ipRestriction->setDtinclusao($dateNow);
            $ipRestriction->setNrorg($orgId);
        }
        $ipRestriction->setDsObsIpRestricted($description);
        $ipRestriction->setNrorgultatu($currentOrgId);
        $ipRestriction->setCdoperultatu($codOperador);
        $ipRestriction->setDsIpv6Restricted($ipv6);
        $ipRestriction->setDsIpv4Restricted($ipv4);
        $ipRestriction->setDtultatu($dateNow);
        $ipRestriction->setIdativo($active);
        
        return $ipRestriction;
    }
}
